# -*- coding: utf-8 -*-
"""
This is only to get a traceback as a string
"""
from builtins import str
from builtins import map
from builtins import object
import sys, traceback
class ExceptionReporting(object):

    @classmethod
    def getTraceback(cls):
        return sys.exc_info()[2]

    @classmethod
    def getTracebackAsString(cls, e):
        tb = cls.getTraceback()
        # traceback.format_exception() no lo usamos por evitar UnicodeEncodeError en caso de que el mensaje de la excepcion tenga acentos
        tbLines = traceback.format_tb(tb)
        tbLines = list(map(cls.str, tbLines))
        stackTrace = (
            "Traceback (Most recent call last):\n\n" +
            u"\n".join(tbLines)+u"\n" +
            str(str(e))
            )
        return stackTrace

    @staticmethod
    def str(msg):
        if not isinstance(msg, str):
            try:
                msg = str(msg, 'UTF8')
            except:
                try:
                    msg = msg.decode("iso8859-1")
                except:
                    msg = str(msg, 'UTF8', errors='replace')
        return msg

